COMMENT ^
This program produces a user-customisable toolbar. It also illustrates how to produce a dropdown button

Visit http://www.win32asmboard.cjb.net/ or www.masmforum.com  

This code may be copied and altered as required provided that no charge is made for it
; #########################################################################^
      .386                   ; minimum processor needed for 32 bit
      .model flat, stdcall   ; FLAT memory model & STDCALL calling
      option casemap :none   ; set code to case sensitive
; #########################################################################      
      include \masm32\include\windows.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\comctl32.inc
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\comctl32.lib   
; #########################################################################
	WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD
	WndProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
	MakeMyToolBar PROTO :DWord
	SetMyToolBarTips PROTO :DWord
	CustomiseToolbar PROTO :DWORD
	DropDownSelected PROTO :DWORD
; #########################################################################       

.const
	FileMENU	    EQU	600		;These menu constants are copied from the resource file
	CM_FileSave		EQU 112
	CM_FileSaveAs	EQU 113
	CM_TRIANGLE		EQU	103
	CM_CIRCLE		EQU	104
	CM_LINE			EQU	105
	CM_EditCut	 	EQU	111
	CM_SQUARE		EQU	107
	CM_FILEEXIT 	EQU	102
	CM_HelpAbout	EQU	106
	CM_EditCopy		EQU 110

	IDToolBar			EQU 400
	TotalButtons		EQU	8		;Number of buttons in the bitmap for the toolbar - exclude separator
	ButtonsToShow		EQU 8		;Number of buttons to show initially inc separators
	MyTBBitMap	 		EQU 1000

.data
	szAppName           db "Toolbar demonstration",0
	szClassName         db "BasicClass",0
	szAboutText			db "Visit:",10,13,10,13
						db "www.win32asmboard.cjb.net",10,13,10,13
						db "or",10,13,10,13
						db "www.masmforum.com",10,13,10,13
						db "This code may be copied and altered as required provided that no charge is made for it"
						db 0
	CommandLine         dd 0
	hMainWnd            dd 0        
	hInstance           dd 0    ;a handle that identifies the program
       
	hToolBar 			dd 0	;handle for toolbar
	szButton1Tip		db "Square",0
	szButton2Tip		db "Circle",0
	szButton3Tip		db "Triangle",0
	szSeparator			db 255,0				;Blank string for the separator in the initail set up
	szLine				db "Line",0
	szCut				db "Cut",0
	szPaste				db "Paste",0
	szFileSave			db "Save file",0
	szFileSaveAs		db "Save file as",0
		
	btnStringAddress	dd TotalButtons dup(0)    ;Array to hold the address of each string
	btnStringLength		dw TotalButtons dup(0)    ;Array to hold the size of each string
		
	align 4
	tbButtons	TBBUTTON <0, CM_SQUARE,TBSTATE_ENABLED,TBSTYLE_BUTTON, 0,0>		;first button
				TBBUTTON <1, CM_CIRCLE, TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>		;second button
				TBBUTTON <2, CM_TRIANGLE, TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>	;third button	
				TBBUTTON <0,0, TBSTATE_ENABLED,TBSTYLE_SEP,0,0>					;separator
				TBBUTTON <3, CM_LINE, TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>		;etc
				TBBUTTON <4, CM_EditCut, TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
				TBBUTTON <5, CM_EditCopy, TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
				TBBUTTON <6, CM_FileSave, TBSTATE_ENABLED,TBSTYLE_DROPDOWN,0,0>
				
	tbButTemp	 TBBUTTON 10 Dup({})		;temp array to hold buttons for teh reset button
	
 ButtonsToSave dd 0		;used when resetting toolbar
 PtrSavedButtons dd 0	;used when resetting toolbar
 hSavedButtons dd 0		;used when resetting toolbar
	
; ##############################################################################

    ShowMyMessage MACRO MyText:REQ, szMsgCaption
      LOCAL Name
      LOCAL MsgCaption
      .const
        Name db MyText,0
        IFB <szMsgCaption>
            MsgCaption db "Message:", 0
        ELSE
            MsgCaption db szMsgCaption,0
        ENDIF      
      .code  
         pushad ;Push all registers
         pushfd ;Push all flags
         invoke MessageBox,0,ADDR Name,ADDR MsgCaption, MB_OK         
         popfd
         popad      
      ENDM


.code
start:
    invoke GetModuleHandle, NULL 
    mov hInstance, eax
    invoke GetCommandLine           
    mov CommandLine, eax
    invoke InitCommonControls
    invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT 
    invoke ExitProcess,eax       	
; #########################################################################
WinMain proc hInst:DWORD, hPrevInst :DWORD, CmdLine:DWORD, CmdShow:DWORD

;hInst is a handle that identifies the program
;hPrevInst specifies the program that hInst is related to (if any)
;CmdLine specifies command line arguments
;CmdShow specifies the state of the main window when it first opens

        LOCAL wc   :WNDCLASSEX
        LOCAL msg  :MSG
        LOCAL Wwd  :DWORD       ;Window width
        LOCAL Wht  :DWORD       ;Window height
        LOCAL Wtx  :DWORD
        LOCAL Wty  :DWORD
        
        ; --------Fill WNDCLASSEX structure with required variables----------
        
	mov  wc.cbSize,         sizeof WNDCLASSEX
	mov  wc.style,          CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
	mov  wc.lpfnWndProc,    offset WndProc      ;address of WndProc
	mov  wc.cbClsExtra,     NULL
	mov  wc.cbWndExtra,     NULL
	push hInst
	pop  wc.hInstance
	mov  wc.hbrBackground,  COLOR_BTNFACE+1     ;system color
	mov  wc.lpszMenuName,   NULL
	mov  wc.lpszClassName,  offset szClassName  ;window class name
      invoke LoadIcon,hInst,500                ;icon ID - resource icon
	mov  wc.hIcon,          eax
      invoke LoadCursor,NULL,IDC_ARROW         ;system cursor
	mov  wc.hCursor,        eax
	mov  wc.hIconSm,        0

	  invoke RegisterClassEx, ADDR wc            ;register the window class

	mov  Wtx,100                        
	mov  Wty,100
	mov  Wwd,600                               ;Initialise window width to 200 pixels
	mov  Wht,400                               ;Initialise window height to 200 pixels

	invoke CreateWindowEx,WS_EX_LEFT, ADDR szClassName, ADDR szAppName,
                          WS_OVERLAPPEDWINDOW, Wtx,Wty,Wwd,Wht,
                          NULL,NULL, hInst,NULL
                              
	mov  hMainWnd,eax                             ; copy return value into handle DWORD
	invoke LoadMenu,hInst,600                 ; load resource menu
	invoke SetMenu,hMainWnd,eax                   ; set it to main window
	invoke ShowWindow,hMainWnd,SW_SHOWNORMAL      ; display the window
	invoke UpdateWindow,hMainWnd                  ; update the display

 ;============== Loop until PostQuitMessage is sent ===================    

    StartLoop:
      invoke GetMessage,ADDR msg,NULL,0,0         ; get each message
      cmp eax, 0                                  ; exit if GetMessage()
      je ExitLoop                                 ; returns zero
      invoke TranslateMessage, ADDR msg           ; translate it
      invoke DispatchMessage,  ADDR msg           ; send it to message proc
      jmp StartLoop     
    ExitLoop:
      mov eax, msg.wParam
      ret
      
WinMain endp

; #########################################################################

WndProc proc hWin: DWORD, uMsg: DWORD, wParam: DWORD, lParam: DWORD


    .if uMsg == WM_COMMAND

   
        ;======== menu commands ========

	.if wParam == 102   ; Exit command on file menu
		invoke SendMessage,hWin,WM_SYSCOMMAND,SC_CLOSE,NULL
            
	.elseif wParam == 106  ; About command on menu            
		invoke MessageBox,hWin,ADDR szAboutText,ADDR szAppName,MB_OK;
	
	.elseif wParam == 112            
		invoke MessageBox,hWin,ADDR szFileSave,ADDR szAppName,MB_OK;            
	.elseif wParam == 113            
		invoke MessageBox,hWin,ADDR szFileSaveAs,ADDR szAppName,MB_OK;            
            
        ;====== end menu commands ======
	.endif
       
	.elseif uMsg == WM_SIZE
		invoke SendMessage,hToolBar,TB_AUTOSIZE,0,0

	.elseif uMsg==WM_NOTIFY 
	mov ebx,lParam						;pointer to TBNOTIFY structure. The first part of TBNOTIFY
										;is a NMHDR structure
;	mov eax,[ebx].NMHDR.code			;move notification code into eax
	mov eax,[ebx].TBNOTIFY.hdr.code		;move notification code into eax
	cmp eax, TTN_GETDISPINFO 			;show a tooltip?
	jne @f								;no - check next notification message
	invoke SetMyToolBarTips, lParam		;yes - call tooltip procedure
	ret 0
@@:
	cmp eax,TBN_DROPDOWN
	jne @F
	invoke DropDownSelected, lParam
	mov eax,0
	ret	
@@:	
	cmp eax,TBN_QUERYINSERT				;if notification code = TBN_QUERYINSERT then return TRUE in eax
	je  Ret1
	cmp eax,TBN_QUERYDELETE				;if notification code = TBN_QUERYDELETE then return TRUE in eax
	je  Ret1
	cmp eax,TBN_TOOLBARCHANGE			;if notification code = TBN_TOOLBARCHANGE then set button size
	jne @f
	mov eax, 14h						;button size
	shl eax,16							;put in high word of eax
	mov ax, 14h							;button size in low word of eax
	invoke SendMessage,hToolBar,TB_SETBUTTONSIZE,0,eax
	jmp Ret1
@@:
	cmp eax,TBN_INITCUSTOMIZE
	jne @f
	mov eax, 0						;show help button
	ret
@@:
	cmp eax,TBN_CUSTHELP
	jne @f
	ShowMyMessage "Help button clicked"
	mov eax,0
	ret
@@:
	cmp eax, TBN_ENDADJUST				;user finished customising the toolbar
	jne @f
	mov eax,1
	ret
@@:	
	cmp eax, TBN_RESET						;did user click the reset button?
	jne @f								;No - check next notification
	invoke SendMessage,hToolBar,TB_BUTTONCOUNT,0,0	;count buttons on toolbar
	mov ecx,eax					;store number of buttons to remove from toolbar in ecx
DelNextButton:
	dec ecx						;subtract 1 because first button has the index 0
	invoke SendMessage,hToolBar,TB_DELETEBUTTON,ecx,0	;delete next button
	cmp ecx,0							;have all buttons been deleted from the toolbar?

jne DelNextButton					;No - delete next button
										;Yes -restore original set of buttons
	invoke SendMessage,hToolBar,TB_ADDBUTTONS,ButtonsToShow,addr tbButtons 
	mov eax,1	 ;return 1
	ret
@@:
	cmp     eax,TBN_GETBUTTONINFO		;check for TBN_GETBUTTONINFO notification
	jne     Ret1

	mov eax,[ebx].TBNOTIFY.iItem		;get IItem index in eax; ebx = lParam at this point
	mov ecx,eax							;copy item number to ecx for later use
	cmp eax,TotalButtons				;have all buttons been processed?
	je  Ret0							;Yes - return 0 to signify end of list
	shl eax,2							;Multiply eax by 4, the size of a DWORD
	add eax, offset btnStringAddress	;add offset to array storing button addresses
	mov esi,[eax]						;esi contains the address of the required string

	mov eax, sizeof TBBUTTON			;size of button structure
	mul cx								;eax = Item number*size of button structure
	add eax, offset tbButtons			;eax points to start of button structure holding our styles etc
	mov edi,eax							;esi points to the TBBUTTON structure holding our styles etc
										;for the required button
								        ;Address of string no N is: btnStringAddress+N*4

	mov  eax, [edi].TBBUTTON.iBitmap
	mov [ebx+16],eax 					;ebx+16=address of start of the TBBUTTON structure in the TBNOTIFY structure
	mov eax,[edi].TBBUTTON.idCommand
	mov [ebx+20],eax
	mov al,[edi].TBBUTTON.fsState
	mov [ebx+24],al
	mov al,[edi].TBBUTTON.fsStyle
	mov [ebx+25],al
	mov eax,[edi].TBBUTTON.dwData
	mov [ebx+28],eax
	mov eax,[edi].TBBUTTON.iString		;index to string - not the address of the string location
	mov [ebx+32],eax

	shl ecx,1							;Multiply button number by 2 to get address of string length
	add ecx, offset btnStringLength		;address of length of string
	mov eax,[ecx]						;get length of string in eax

mov ebx,lParam							;ebx=lParam
mov [ebx].TBNOTIFY.cchText,eax			;store length of string
pushad
invoke lstrcpy, [ebx].TBNOTIFY.pszText, esi
popad
jmp Ret1

Ret1:
	mov eax,TRUE	
	ret
Ret0:
	mov eax,0
	ret

    .elseif uMsg == WM_CREATE
    	invoke MakeMyToolBar,hWin

    .elseif uMsg == WM_DESTROY   
        invoke PostQuitMessage,NULL
        mov eax,0
        ret
    .endif

    invoke DefWindowProc,hWin,uMsg,wParam,lParam

    ret

WndProc endp
; #########################################################################
MakeMyToolBar proc hWin:DWord	

	invoke CreateToolbarEx, hWin,		;hWin is the handle of the main window
			WS_CHILD or WS_CLIPSIBLINGS or TBSTYLE_TOOLTIPS or TBSTYLE_FLAT or WS_BORDER or CCS_ADJUSTABLE,
			IDToolBar,TotalButtons,hInstance,MyTBBitMap,ADDR tbButtons,
			ButtonsToShow,16,16,16,16,sizeof TBBUTTON

	mov hToolBar, eax											;store toolbar handle
	.if eax==NULL 
			ShowMyMessage "Error"
	.endif
	invoke SendMessage,hToolBar,TB_SETEXTENDEDSTYLE,0, TBSTYLE_EX_DRAWDDARROWS
	invoke ShowWindow, hToolBar, SW_SHOW
pushad    
mov eax,0                           ;initialise buttons processed counter to 0
mov ebx,offset btnStringLength      ;initialise string length pointer
mov esi, offset szButton1Tip	    ;address of first string
mov edi, offset btnStringAddress    ;initialise pointer for storing string addresses
NextString:
    mov dword ptr[edi],esi          ;store address of string
    mov cx,0						;string length counter
NextChar:       
    inc esi                         ;increase string pointer
    cmp byte ptr[esi],0             ;end of string?
    je EndStr                       ;Yes - jump
    inc cx							; No - increase string length counter
    jmp NextChar                    ; and check next character
EndStr:
    inc cx
    mov word ptr[ebx],cx            ;store string length
    inc ebx                         ;increase pointer for string length
    inc ebx
    inc edi                         ;increase pointer for storing next string address
    inc edi
    inc edi
    inc edi
    inc esi                         ;point esi to first character of next string
    inc eax                         ;increase buttons processed coutner
    cmp ax, TotalButtons			;have all buttons been processed?
    jne NextString                  ;No - process next string

;Addres of string no N is: btnStringAddress+N*4, the length of DWORD being 4
;Length of string N is: btnStringLength+N*2, the length of WORD being 2
popad  
	
	ret
MakeMyToolBar endp
; #########################################################################
SetMyToolBarTips proc uses edi nmtdi:DWORD 
     
    mov edi,nmtdi 
    assume edi:ptr NMTTDISPINFO      
        mov [edi].hinst,NULL							;must be NULL since lpszText is used below 
        mov [edi].uFlags,TTF_DI_SETITEM					;do not request the text again 
     
        .if [edi].hdr.idFrom==CM_SQUARE					;Command identifier for first button 
            mov [edi].lpszText, offset szButton1Tip		;address of tip text for first button
        .elseif [edi].hdr.idFrom==CM_CIRCLE				;Command identifier for second button 
            mov [edi].lpszText, offset szButton2Tip		;address of tip text for second button
        .elseif [edi].hdr.idFrom==CM_TRIANGLE			;Command identifier for third button
            mov [edi].lpszText, offset szButton3Tip		;address of tip text for third button
         .elseif [edi].hdr.idFrom==CM_LINE				;Command identifier for third button
            mov [edi].lpszText, offset szLine			;address of tip text for third button
        .elseif [edi].hdr.idFrom==CM_EditCut
            mov [edi].lpszText, offset szCut  
        .elseif [edi].hdr.idFrom==CM_EditCopy
            mov [edi].lpszText, offset szPaste 
        .elseif [edi].hdr.idFrom==CM_FileSave
            mov [edi].lpszText, offset szFileSave
        .endif 
    assume edi:NOTHING
    ret 
SetMyToolBarTips endp 
; #########################################################################
DropDownSelected proc uses edi edx,LParam: DWORD
	LOCAL ButtonRect : RECT
	LOCAL hPopupMenu	:DWORD
	
	mov edi,LParam						;pointer to NMTOOLBAR structure	
	mov edx,[edi].NMTOOLBAR.iItem		;Get command identifier of the clicked button
	invoke SendMessage,  hToolBar, TB_GETRECT, edx, Addr ButtonRect ;Get rect of clicked button				
	invoke MapWindowPoints,hToolBar,0,Addr ButtonRect,2	;Convert from client to screen co-ordinates
	invoke CreatePopupMenu								;Create a pop-up menu
	mov hPopupMenu,eax										;Store popup handle
	invoke AppendMenu,hPopupMenu,MF_STRING,CM_FileSave,addr szFileSave
	invoke AppendMenu,hPopupMenu,MF_STRING,CM_FileSaveAs,addr szFileSaveAs	
	invoke TrackPopupMenu,hPopupMenu,TPM_LEFTALIGN+TPM_LEFTBUTTON,ButtonRect.left,ButtonRect.bottom,0,hMainWnd,0
	invoke DestroyMenu,hPopupMenu							;Destroy popup window
	mov eax,0			;Return false, otherwise button will appear to be depressed
	ret
DropDownSelected endp
end start

